'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('geteventstore:aggRoot');

var AggRoot = function AggRoot(when) {
	var eventHandlers = when;

	this.handle = function (events) {
		debug('', 'Handling Events: %j', events);
		var self = this;
		if (events.length > 0) {
			for (var i = 0; i < events.length; i++) {
				var ev = events[i];
				if (eventHandlers[ev.eventType] !== undefined) {
					eventHandlers[ev.eventType].call(self, ev);
					if (ev.eventNumber !== undefined) {
						self._version = ev.eventNumber;
					}
				}
			}
		}
	};
};

exports.default = AggRoot;
module.exports = exports['default'];