'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _requestPromise = require('request-promise');

var _requestPromise2 = _interopRequireDefault(_requestPromise);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('geteventstore:checkStreamExists');
var baseErr = 'Check Stream Exists - ';

exports.default = function (config) {
	return function () {
		var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(streamName) {
			var options, response;
			return _regenerator2.default.wrap(function _callee$(_context) {
				while (1) {
					switch (_context.prev = _context.next) {
						case 0:
							(0, _assert2.default)(streamName, baseErr + 'Stream Name not provided');

							options = {
								uri: config.baseUrl + '/streams/' + streamName + '/head/backward/1',
								method: 'GET',
								json: true,
								headers: {
									"Content-Type": "application/vnd.eventstore.events+json"
								},
								timeout: config.timeout
							};


							debug('', 'Options: %j', options);
							_context.prev = 3;
							_context.next = 6;
							return (0, _requestPromise2.default)(options);

						case 6:
							response = _context.sent;

							debug('', 'Response: %j', response);
							return _context.abrupt('return', true);

						case 11:
							_context.prev = 11;
							_context.t0 = _context['catch'](3);

							if (!(_context.t0.statusCode !== 404)) {
								_context.next = 15;
								break;
							}

							throw _context.t0;

						case 15:
							return _context.abrupt('return', false);

						case 16:
						case 'end':
							return _context.stop();
					}
				}
			}, _callee, undefined, [[3, 11]]);
		}));

		return function (_x) {
			return _ref.apply(this, arguments);
		};
	}();
};

module.exports = exports['default'];