'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _requestPromise = require('request-promise');

var _requestPromise2 = _interopRequireDefault(_requestPromise);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('geteventstore:deleteStream');
var baseErr = 'Delete Stream - ';

exports.default = function (config) {
	var checkStreamExists = require('./checkStreamExists')(config);

	return function () {
		var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(streamName, hardDelete) {
			var exists, options, response;
			return _regenerator2.default.wrap(function _callee$(_context) {
				while (1) {
					switch (_context.prev = _context.next) {
						case 0:
							(0, _assert2.default)(streamName, baseErr + 'Stream Name not provided');

							_context.next = 3;
							return checkStreamExists(streamName);

						case 3:
							exists = _context.sent;

							if (exists) {
								_context.next = 6;
								break;
							}

							throw new Error('Stream does not exist');

						case 6:
							options = {
								uri: config.baseUrl + '/streams/' + streamName,
								method: 'DELETE',
								resolveWithFullResponse: true,
								timeout: config.timeout
							};


							if (hardDelete) {
								options.headers = {
									"ES-HardDelete": "true"
								};
							}

							debug('', 'Options: %j', options);
							_context.next = 11;
							return (0, _requestPromise2.default)(options);

						case 11:
							response = _context.sent;

							debug('', 'Response: %j', response);
							return _context.abrupt('return', response);

						case 14:
						case 'end':
							return _context.stop();
					}
				}
			}, _callee, undefined);
		}));

		return function (_x, _x2) {
			return _ref.apply(this, arguments);
		};
	}();
};

module.exports = exports['default'];