'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _mapEvents = require('./utilities/mapEvents');

var _mapEvents2 = _interopRequireDefault(_mapEvents);

var _requestPromise = require('request-promise');

var _requestPromise2 = _interopRequireDefault(_requestPromise);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('geteventstore:getEvents');
var baseErr = 'Get Events - ';

exports.default = function (config) {
	return function () {
		var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(streamName, startPosition, length, direction, resolveLinkTos) {
			var embed = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : 'body';
			var options, response, totalEntries, i;
			return _regenerator2.default.wrap(function _callee$(_context) {
				while (1) {
					switch (_context.prev = _context.next) {
						case 0:
							(0, _assert2.default)(streamName, baseErr + 'Stream Name not provided');

							length = length || 1000;

							if (length > 4096) {
								console.warn('WARNING: Max event return limit exceeded. Using the max of 4096');
								length = 4096;
							}

							direction = direction || 'forward';
							startPosition = startPosition === undefined && direction === 'backward' ? 'head' : startPosition || 0;
							resolveLinkTos = resolveLinkTos === undefined ? true : resolveLinkTos;

							options = {
								uri: config.baseUrl + '/streams/' + streamName + '/' + startPosition + '/' + direction + '/' + length,
								method: 'GET',
								headers: {
									"Content-Type": "application/vnd.eventstore.events+json",
									"ES-ResolveLinkTos": resolveLinkTos.toString()
								},
								qs: {
									embed: embed
								},
								json: true,
								timeout: config.timeout
							};


							debug('', 'Options: ', options);
							_context.next = 10;
							return (0, _requestPromise2.default)(options);

						case 10:
							response = _context.sent;

							if (embed === 'body') {
								totalEntries = response.entries.length;

								for (i = 0; i < totalEntries; i++) {
									if (response.entries[i].data) response.entries[i].data = JSON.parse(response.entries[i].data);
								}
							}

							if (!(direction === 'forward')) {
								_context.next = 14;
								break;
							}

							return _context.abrupt('return', (0, _mapEvents2.default)(response.entries.reverse()));

						case 14:
							return _context.abrupt('return', (0, _mapEvents2.default)(response.entries));

						case 15:
						case 'end':
							return _context.stop();
					}
				}
			}, _callee, undefined);
		}));

		return function (_x2, _x3, _x4, _x5, _x6) {
			return _ref.apply(this, arguments);
		};
	}();
};

module.exports = exports['default'];