'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _requestPromise = require('request-promise');

var _requestPromise2 = _interopRequireDefault(_requestPromise);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('geteventstore:assertProjection');
var baseErr = 'Assert Projection - ';

var doesProjectionExist = function () {
	var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(config, name) {
		var getAllProjectionsInfo, projectionsInfo, projection;
		return _regenerator2.default.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						getAllProjectionsInfo = require('./getAllProjectionsInfo')(config);
						_context.next = 3;
						return getAllProjectionsInfo();

					case 3:
						projectionsInfo = _context.sent;
						projection = _lodash2.default.find(projectionsInfo.projections, function (projection) {
							return projection.name === name;
						});

						if (!projection) {
							_context.next = 7;
							break;
						}

						return _context.abrupt('return', true);

					case 7:
						return _context.abrupt('return', false);

					case 8:
					case 'end':
						return _context.stop();
				}
			}
		}, _callee, undefined);
	}));

	return function doesProjectionExist(_x, _x2) {
		return _ref.apply(this, arguments);
	};
}();

var buildCreateOptions = function buildCreateOptions(config, name, projectionContent, mode, enabled, emitEnabled, checkpointsEnabled) {
	var options = {
		uri: config.baseUrl + '/projections/' + mode,
		method: 'POST',
		headers: {
			'Content-Type': 'application/json'
		},
		qs: {
			name: name,
			enabled: enabled ? 'yes' : 'no',
			emit: emitEnabled ? 'yes' : 'no',
			checkpoints: checkpointsEnabled ? 'yes' : 'no'
		},
		body: projectionContent
	};

	return options;
};

var buildUpdateOptions = function buildUpdateOptions(config, name, projectionContent, emitEnabled) {
	var options = {
		uri: config.baseUrl + '/projection/' + name + '/query',
		method: 'PUT',
		headers: {
			'Content-Type': 'application/json'
		},
		qs: {
			emit: emitEnabled ? 'yes' : 'no'
		},
		body: projectionContent
	};

	return options;
};

exports.default = function (config) {
	return function () {
		var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(name, projectionContent, mode, enabled, checkpointsEnabled, emitEnabled) {
			var projectionExists, options, response;
			return _regenerator2.default.wrap(function _callee2$(_context2) {
				while (1) {
					switch (_context2.prev = _context2.next) {
						case 0:
							(0, _assert2.default)(name, baseErr + 'Name not provided');
							(0, _assert2.default)(projectionContent, baseErr + 'Projection Content not provided');

							mode = mode || 'continuous';
							enabled = enabled || true;
							checkpointsEnabled = mode === 'continuous' ? true : checkpointsEnabled || false;
							emitEnabled = emitEnabled || false;

							_context2.next = 8;
							return doesProjectionExist(config, name);

						case 8:
							projectionExists = _context2.sent;

							debug('', 'Projection Exists: %j', projectionExists);

							options = {};

							if (!projectionExists) options = buildCreateOptions(config, name, projectionContent, mode, enabled, emitEnabled, checkpointsEnabled);else options = buildUpdateOptions(config, name, projectionContent, emitEnabled);

							debug('', 'Options: %j', options);
							_context2.next = 15;
							return (0, _requestPromise2.default)(options);

						case 15:
							response = _context2.sent;

							debug('', 'Response: %j', response);
							return _context2.abrupt('return', JSON.parse(response));

						case 18:
						case 'end':
							return _context2.stop();
					}
				}
			}, _callee2, undefined);
		}));

		return function (_x3, _x4, _x5, _x6, _x7, _x8) {
			return _ref2.apply(this, arguments);
		};
	}();
};

module.exports = exports['default'];