'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('geteventstore:getProjectionInfo');
var baseErr = 'Get Projection Info - ';

exports.default = function (config) {
	var getAllProjectionsInfo = require('./getAllProjectionsInfo')(config);

	return function () {
		var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(name) {
			var projectionsInfo, projectionInfo;
			return _regenerator2.default.wrap(function _callee$(_context) {
				while (1) {
					switch (_context.prev = _context.next) {
						case 0:
							(0, _assert2.default)(name, baseErr + 'Name not provided');

							_context.next = 3;
							return getAllProjectionsInfo();

						case 3:
							projectionsInfo = _context.sent;
							projectionInfo = _lodash2.default.find(projectionsInfo.projections, function (projection) {
								return projection.name === name;
							});

							debug('', 'Projection Info: %j', projectionInfo);
							return _context.abrupt('return', projectionInfo);

						case 7:
						case 'end':
							return _context.stop();
					}
				}
			}, _callee, undefined);
		}));

		return function (_x) {
			return _ref.apply(this, arguments);
		};
	}();
};

module.exports = exports['default'];