'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _requestPromise = require('request-promise');

var _requestPromise2 = _interopRequireDefault(_requestPromise);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('geteventstore:writeEvents');
var baseErr = 'Write Events - ';

exports.default = function (config) {
	return function () {
		var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(streamName, events, options) {
			var reqOptions;
			return _regenerator2.default.wrap(function _callee$(_context) {
				while (1) {
					switch (_context.prev = _context.next) {
						case 0:
							(0, _assert2.default)(streamName, baseErr + 'Stream Name not provided');
							(0, _assert2.default)(events, baseErr + 'Events not provided');
							_assert2.default.equal(true, events.constructor === Array, baseErr + 'Events should be an array');

							if (!(events.length === 0)) {
								_context.next = 5;
								break;
							}

							return _context.abrupt('return');

						case 5:

							options = options || {};
							options.expectedVersion = options.expectedVersion || -2;

							reqOptions = {
								uri: config.baseUrl + '/streams/' + streamName,
								headers: {
									"Content-Type": "application/vnd.eventstore.events+json",
									"ES-ExpectedVersion": options.expectedVersion
								},
								method: 'POST',
								body: events,
								json: true,
								timeout: config.timeout
							};


							debug('', 'Write events: %j', reqOptions);
							return _context.abrupt('return', (0, _requestPromise2.default)(reqOptions));

						case 10:
						case 'end':
							return _context.stop();
					}
				}
			}, _callee, undefined);
		}));

		return function (_x, _x2, _x3) {
			return _ref.apply(this, arguments);
		};
	}();
};

module.exports = exports['default'];