'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _connectionManager = require('./connectionManager');

var _connectionManager2 = _interopRequireDefault(_connectionManager);

var _nodeEventstoreClient = require('node-eventstore-client');

var _nodeEventstoreClient2 = _interopRequireDefault(_nodeEventstoreClient);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var baseErr = 'Check stream exits - ';

exports.default = function (config) {
	return function () {
		var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(streamName) {
			var connection, slice;
			return _regenerator2.default.wrap(function _callee$(_context) {
				while (1) {
					switch (_context.prev = _context.next) {
						case 0:
							(0, _assert2.default)(streamName, baseErr + 'Stream Name not provided');

							_context.next = 3;
							return _connectionManager2.default.create(config);

						case 3:
							connection = _context.sent;
							_context.prev = 4;
							_context.next = 7;
							return connection.readStreamEventsForward(streamName, 0, 1, true, config.credentials);

						case 7:
							slice = _context.sent;

							if (!(slice.status === _nodeEventstoreClient2.default.sliceReadStatus.StreamDeleted)) {
								_context.next = 10;
								break;
							}

							throw new Error('Stream hard deleted');

						case 10:
							if (!(slice.status === _nodeEventstoreClient2.default.sliceReadStatus.StreamNotFound)) {
								_context.next = 12;
								break;
							}

							return _context.abrupt('return', false);

						case 12:
							return _context.abrupt('return', true);

						case 15:
							_context.prev = 15;
							_context.t0 = _context['catch'](4);
							throw _context.t0;

						case 18:
							_context.prev = 18;

							connection.releaseConnection();
							return _context.finish(18);

						case 21:
						case 'end':
							return _context.stop();
					}
				}
			}, _callee, undefined, [[4, 15, 18, 21]]);
		}));

		return function (_x) {
			return _ref.apply(this, arguments);
		};
	}();
};

module.exports = exports['default'];