'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _connectionManager = require('./connectionManager');

var _connectionManager2 = _interopRequireDefault(_connectionManager);

var _mapEvents = require('./utilities/mapEvents');

var _mapEvents2 = _interopRequireDefault(_mapEvents);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('geteventstore:getAllStreamEvents');
var baseErr = 'Get All Stream Events - ';

exports.default = function (config) {
	return function () {
		var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(streamName, chunkSize, startPosition, resolveLinkTos) {
			var getNextChunk = function () {
				var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(startPosition) {
					var result;
					return _regenerator2.default.wrap(function _callee$(_context) {
						while (1) {
							switch (_context.prev = _context.next) {
								case 0:
									_context.next = 2;
									return connection.readStreamEventsForward(streamName, startPosition, chunkSize, resolveLinkTos, config.credentials);

								case 2:
									result = _context.sent;

									debug('', 'Result: %j', result);

									if (_lodash2.default.isEmpty(result.error)) {
										_context.next = 6;
										break;
									}

									throw new Error(result.error);

								case 6:

									events.push(result.events);

									if (!(result.isEndOfStream === false)) {
										_context.next = 11;
										break;
									}

									return _context.abrupt('return', getNextChunk(result.nextEventNumber));

								case 11:
									return _context.abrupt('return', (0, _mapEvents2.default)(_lodash2.default.flatten(events)));

								case 12:
								case 'end':
									return _context.stop();
							}
						}
					}, _callee, this);
				}));

				return function getNextChunk(_x5) {
					return _ref2.apply(this, arguments);
				};
			}();

			var connection, events;
			return _regenerator2.default.wrap(function _callee2$(_context2) {
				while (1) {
					switch (_context2.prev = _context2.next) {
						case 0:
							(0, _assert2.default)(streamName, baseErr + 'Stream Name not provided');

							chunkSize = chunkSize || 1000;
							if (chunkSize > 4096) {
								console.warn('WARNING: Max event chunk size exceeded. Using the max of 4096');
								chunkSize = 4096;
							}
							resolveLinkTos = resolveLinkTos === undefined ? true : resolveLinkTos;

							_context2.next = 6;
							return _connectionManager2.default.create(config);

						case 6:
							connection = _context2.sent;
							events = [];
							_context2.prev = 8;
							_context2.next = 11;
							return getNextChunk(startPosition || 0);

						case 11:
							return _context2.abrupt('return', _context2.sent);

						case 14:
							_context2.prev = 14;
							_context2.t0 = _context2['catch'](8);
							throw _context2.t0;

						case 17:
							_context2.prev = 17;

							connection.releaseConnection();
							return _context2.finish(17);

						case 20:
						case 'end':
							return _context2.stop();
					}
				}
			}, _callee2, undefined, [[8, 14, 17, 20]]);
		}));

		return function (_x, _x2, _x3, _x4) {
			return _ref.apply(this, arguments);
		};
	}();
};

module.exports = exports['default'];