'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _connectionManager = require('./connectionManager');

var _connectionManager2 = _interopRequireDefault(_connectionManager);

var _mapEvents = require('./utilities/mapEvents');

var _mapEvents2 = _interopRequireDefault(_mapEvents);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('geteventstore:getevents');
var baseErr = 'Get Events - ';

exports.default = function (config) {
	return function () {
		var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(streamName, startPosition, length, direction, resolveLinkTos) {
			var connection, handleResult;
			return _regenerator2.default.wrap(function _callee$(_context) {
				while (1) {
					switch (_context.prev = _context.next) {
						case 0:
							handleResult = function handleResult(result) {
								debug('', 'Result: %j', result);
								if (!_lodash2.default.isEmpty(result.error)) throw new Error(result.error);
								return (0, _mapEvents2.default)(result.events);
							};

							(0, _assert2.default)(streamName, baseErr + 'Stream Name not provided');

							direction = direction || 'forward';
							startPosition = startPosition === undefined && direction === 'backward' ? -1 : startPosition || 0;
							length = length || 1000;
							resolveLinkTos = resolveLinkTos === undefined ? true : resolveLinkTos;

							if (length > 4096) {
								console.warn('WARNING: Max event return limit exceeded. Using the max of 4096');
								length = 4096;
							}

							_context.next = 9;
							return _connectionManager2.default.create(config);

						case 9:
							connection = _context.sent;
							_context.prev = 10;

							if (!(direction === 'forward')) {
								_context.next = 15;
								break;
							}

							_context.next = 14;
							return connection.readStreamEventsForward(streamName, startPosition, length, resolveLinkTos, config.credentials).then(handleResult);

						case 14:
							return _context.abrupt('return', _context.sent);

						case 15:
							_context.next = 17;
							return connection.readStreamEventsBackward(streamName, startPosition, length, resolveLinkTos, config.credentials).then(handleResult);

						case 17:
							return _context.abrupt('return', _context.sent);

						case 20:
							_context.prev = 20;
							_context.t0 = _context['catch'](10);
							throw _context.t0;

						case 23:
							_context.prev = 23;

							connection.releaseConnection();
							return _context.finish(23);

						case 26:
						case 'end':
							return _context.stop();
					}
				}
			}, _callee, undefined, [[10, 20, 23, 26]]);
		}));

		return function (_x, _x2, _x3, _x4, _x5) {
			return _ref.apply(this, arguments);
		};
	}();
};

module.exports = exports['default'];