'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _connectionManager = require('./connectionManager');

var _connectionManager2 = _interopRequireDefault(_connectionManager);

var _mapEvents = require('./utilities/mapEvents');

var _mapEvents2 = _interopRequireDefault(_mapEvents);

var _nodeEventstoreClient = require('node-eventstore-client');

var _nodeEventstoreClient2 = _interopRequireDefault(_nodeEventstoreClient);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('geteventstore:subscribeToStreamFrom');
var baseErr = 'Subscribe to Stream From - ';

exports.default = function (config) {
	return function (streamName, fromEventNumber, onEventAppeared, onLiveProcessingStarted, onDropped, settings) {
		settings = settings || {};
		return new _bluebird2.default(function () {
			var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(resolve, reject) {
				var connection, onEvent, onConnected;
				return _regenerator2.default.wrap(function _callee2$(_context2) {
					while (1) {
						switch (_context2.prev = _context2.next) {
							case 0:
								(0, _assert2.default)(streamName, baseErr + 'Stream Name not provided');
								if (!fromEventNumber) fromEventNumber = -1;

								connection = void 0;

								onEvent = function onEvent(sub, ev) {
									var mappedEvent = (0, _mapEvents2.default)([ev])[0];
									if (mappedEvent) onEventAppeared(mappedEvent);
								};

								onConnected = function () {
									var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
										var subscription;
										return _regenerator2.default.wrap(function _callee$(_context) {
											while (1) {
												switch (_context.prev = _context.next) {
													case 0:
														_context.prev = 0;
														_context.next = 3;
														return connection.subscribeToStreamFrom(streamName, fromEventNumber, settings.resolveLinkTos, onEvent, onLiveProcessingStarted, onDropped, new _nodeEventstoreClient2.default.UserCredentials(config.credentials.username, config.credentials.password), settings.readBatchSize);

													case 3:
														subscription = _context.sent;

														debug('', 'Subscription: %j', subscription);
														resolve(subscription);
														_context.next = 11;
														break;

													case 8:
														_context.prev = 8;
														_context.t0 = _context['catch'](0);

														reject(_context.t0);

													case 11:
													case 'end':
														return _context.stop();
												}
											}
										}, _callee, undefined, [[0, 8]]);
									}));

									return function onConnected() {
										return _ref2.apply(this, arguments);
									};
								}();

								_context2.prev = 5;
								_context2.next = 8;
								return _connectionManager2.default.create(config, onConnected, true);

							case 8:
								connection = _context2.sent;
								_context2.next = 14;
								break;

							case 11:
								_context2.prev = 11;
								_context2.t0 = _context2['catch'](5);

								reject(_context2.t0);

							case 14:
							case 'end':
								return _context2.stop();
						}
					}
				}, _callee2, undefined, [[5, 11]]);
			}));

			return function (_x, _x2) {
				return _ref.apply(this, arguments);
			};
		}());
	};
};

module.exports = exports['default'];