'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _connectionManager = require('./connectionManager');

var _connectionManager2 = _interopRequireDefault(_connectionManager);

var _nodeEventstoreClient = require('node-eventstore-client');

var _nodeEventstoreClient2 = _interopRequireDefault(_nodeEventstoreClient);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _uuid = require('uuid');

var _uuid2 = _interopRequireDefault(_uuid);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('geteventstore:writeEvent');
var baseErr = 'Write Event - ';

exports.default = function (config) {
	return function () {
		var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(streamName, eventType, data, metaData, options) {
			var event, connection, result;
			return _regenerator2.default.wrap(function _callee$(_context) {
				while (1) {
					switch (_context.prev = _context.next) {
						case 0:
							(0, _assert2.default)(streamName, baseErr + 'Stream Name not provided');
							(0, _assert2.default)(eventType, baseErr + 'Event Type not provided');
							(0, _assert2.default)(data, baseErr + 'Event Data not provided');

							options = options || {};
							options.expectedVersion = options.expectedVersion || -2;

							event = _nodeEventstoreClient2.default.createJsonEventData(_uuid2.default.v4(), data, metaData, eventType);
							_context.next = 8;
							return _connectionManager2.default.create(config);

						case 8:
							connection = _context.sent;
							_context.prev = 9;
							_context.next = 12;
							return connection.appendToStream(streamName, options.expectedVersion, [event], config.credentials);

						case 12:
							result = _context.sent;

							debug('', 'Result: %j', result);

							if (_lodash2.default.isEmpty(result.error)) {
								_context.next = 16;
								break;
							}

							throw new Error(result.error);

						case 16:
							return _context.abrupt('return', result);

						case 19:
							_context.prev = 19;
							_context.t0 = _context['catch'](9);
							throw _context.t0;

						case 22:
							_context.prev = 22;

							connection.releaseConnection();
							return _context.finish(22);

						case 25:
						case 'end':
							return _context.stop();
					}
				}
			}, _callee, undefined, [[9, 19, 22, 25]]);
		}));

		return function (_x, _x2, _x3, _x4, _x5) {
			return _ref.apply(this, arguments);
		};
	}();
};

module.exports = exports['default'];