'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _connectionManager = require('./connectionManager');

var _connectionManager2 = _interopRequireDefault(_connectionManager);

var _nodeEventstoreClient = require('node-eventstore-client');

var _nodeEventstoreClient2 = _interopRequireDefault(_nodeEventstoreClient);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = (0, _debug2.default)('geteventstore:writeEvents');
var baseErr = 'Write Events - ';

exports.default = function (config) {
	return function () {
		var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(streamName, events, options) {
			var eventsToWrite, connection, transaction, eventChunks, result;
			return _regenerator2.default.wrap(function _callee$(_context) {
				while (1) {
					switch (_context.prev = _context.next) {
						case 0:
							(0, _assert2.default)(streamName, baseErr + 'Stream Name not provided');
							(0, _assert2.default)(events, baseErr + 'Events not provided');
							_assert2.default.equal(true, events.constructor === Array, baseErr + 'Events should be an array');

							if (!(events.length === 0)) {
								_context.next = 5;
								break;
							}

							return _context.abrupt('return');

						case 5:

							options = options || {};
							options.transactionWriteSize = options.transactionWriteSize || 50;
							options.expectedVersion = options.expectedVersion || -2;

							eventsToWrite = _lodash2.default.map(events, function (ev) {
								return _nodeEventstoreClient2.default.createJsonEventData(ev.eventId, ev.data, ev.metadata, ev.eventType);
							});
							_context.next = 11;
							return _connectionManager2.default.create(config);

						case 11:
							connection = _context.sent;
							transaction = void 0;
							_context.prev = 13;
							_context.next = 16;
							return connection.startTransaction(streamName, options.expectedVersion, config.credentials);

						case 16:
							transaction = _context.sent;
							eventChunks = _lodash2.default.chunk(eventsToWrite, options.transactionWriteSize);
							_context.next = 20;
							return _bluebird2.default.each(eventChunks, function (events) {
								return transaction.write(events);
							});

						case 20:
							_context.next = 22;
							return transaction.commit();

						case 22:
							result = _context.sent;

							debug('', 'Result: %j', result);
							return _context.abrupt('return', result);

						case 27:
							_context.prev = 27;
							_context.t0 = _context['catch'](13);

							if (!transaction) {
								_context.next = 32;
								break;
							}

							_context.next = 32;
							return transaction.rollback();

						case 32:
							throw _context.t0;

						case 33:
							_context.prev = 33;

							connection.releaseConnection();
							return _context.finish(33);

						case 36:
						case 'end':
							return _context.stop();
					}
				}
			}, _callee, undefined, [[13, 27, 33, 36]]);
		}));

		return function (_x, _x2, _x3) {
			return _ref.apply(this, arguments);
		};
	}();
};

module.exports = exports['default'];